package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLPWMultiAff_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLPWMultiAff extends JNIObject implements IISLSingleSpaceReadOnlyMapMethods {
	
	/* @generated */
	protected ISLPWMultiAff(long ptr) {
		/*** PROTECTED REGION ID(ISLPWMultiAff_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLPWMultiAff build(long ptr) {
		return new ISLPWMultiAff(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLPWMultiAff_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	
	public List<ISLPWMultiAffPiece> getPieces() {
		int n = getNbPieces();
		
		List<ISLPWMultiAffPiece> pieces = new ArrayList<>(n);
		for (int i = 0; i < n; i++)
			pieces.add(getPiece(i));
		
		return pieces;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_pw_multi_aff_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLPWMultiAff buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_pw_multi_aff_read_from_str) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_alloc 
	 * 
	@take set maff
	 * @generated
	**/
	 public static ISLPWMultiAff build(ISLSet set, ISLMultiAff maff) { 
		/*** PROTECTED REGION ID(static_isl_pw_multi_aff_alloc) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(set, maff);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_alloc(getNativePtr(set), getNativePtr(maff)));
			} finally {
				taken(set);
				taken(maff);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_zero 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLPWMultiAff buildZero(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_pw_multi_aff_zero) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_zero(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_identity 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLPWMultiAff buildIdentity(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_pw_multi_aff_identity) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_identity(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLPWMultiAff buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_pw_multi_aff_empty) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_from_domain 
	 * 
	@take set
	 * @generated
	**/
	 public static ISLPWMultiAff buildFromDomain(ISLSet set) { 
		/*** PROTECTED REGION ID(static_isl_pw_multi_aff_from_domain) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(set);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_from_domain(getNativePtr(set)));
			} finally {
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLPWMultiAff pma, int format) { 
		/*** PROTECTED REGION ID(static_isl_pw_multi_aff_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_multi_aff_to_string(getNativePtr(pma), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_multi_pw_aff_from_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiPWAff toMultiPWAff() {
		/*** PROTECTED REGION ID(isl_multi_pw_aff_from_pw_multi_aff) DISABLED START ***/
		ISLMultiPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiPWAff.build(ISLNative.isl_multi_pw_aff_from_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_from_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff toUnionPWMultiAff() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_from_pw_multi_aff) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_from_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_from_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toMap() {
		/*** PROTECTED REGION ID(isl_map_from_pw_multi_aff) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_from_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_from_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet toSet() {
		/*** PROTECTED REGION ID(isl_set_from_pw_multi_aff) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_from_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_pw_multi_aff_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_pw_multi_aff_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_get_domain_space 
	 * 
	 * @generated
	**/
	public ISLSpace getDomainSpace() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_get_domain_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_pw_multi_aff_get_domain_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_copy 
	 * 
	 * @generated
	**/
	public ISLPWMultiAff copy() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_copy) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_pw_multi_aff_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_multi_aff_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_get_pw_aff 
	 * 
	 * @generated
	**/
	public ISLPWAff getPWAff(int pos) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_get_pw_aff) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_multi_aff_get_pw_aff(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_set_pw_aff 
	 * 
	 * @take this pa
	 * @generated
	**/
	public ISLPWMultiAff setPWAff(int pos, ISLPWAff pa) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_set_pw_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pa);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_set_pw_aff(getNativePtr(this), pos, getNativePtr(pa)));
			} finally {
				taken(this);
				taken(pa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_has_tuple_name 
	 * 
	 * @generated
	**/
	public boolean hasTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_has_tuple_name) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_multi_aff_has_tuple_name(getNativePtr(this), type.getValue()) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_get_tuple_name 
	 * 
	 * @generated
	**/
	public String getTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_get_tuple_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_multi_aff_get_tuple_name(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_multi_aff_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_drop_dims) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet domain() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_domain) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_pw_multi_aff_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLPWMultiAff pma2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_multi_aff_plain_is_equal(getNativePtr(this), getNativePtr(pma2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_union_add 
	 * 
	 * @take this pma2
	 * @generated
	**/
	public ISLPWMultiAff unionAdd(ISLPWMultiAff pma2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_union_add) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma2);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_union_add(getNativePtr(this), getNativePtr(pma2)));
			} finally {
				taken(this);
				taken(pma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_add 
	 * 
	 * @take this pma2
	 * @generated
	**/
	public ISLPWMultiAff add(ISLPWMultiAff pma2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_add) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma2);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_add(getNativePtr(this), getNativePtr(pma2)));
			} finally {
				taken(this);
				taken(pma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_sub 
	 * 
	 * @take this pma2
	 * @generated
	**/
	public ISLPWMultiAff sub(ISLPWMultiAff pma2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_sub) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma2);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_sub(getNativePtr(this), getNativePtr(pma2)));
			} finally {
				taken(this);
				taken(pma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_scale_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLPWMultiAff scale(ISLVal v) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_scale_val) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_scale_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_scale_multi_val 
	 * 
	 * @take this mv
	 * @generated
	**/
	public ISLPWMultiAff scale(ISLMultiVal mv) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_scale_multi_val) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mv);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_scale_multi_val(getNativePtr(this), getNativePtr(mv)));
			} finally {
				taken(this);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_union_lexmin 
	 * 
	 * @take this pma2
	 * @generated
	**/
	public ISLPWMultiAff unionLexMin(ISLPWMultiAff pma2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_union_lexmin) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma2);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_union_lexmin(getNativePtr(this), getNativePtr(pma2)));
			} finally {
				taken(this);
				taken(pma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_union_lexmax 
	 * 
	 * @take this pma2
	 * @generated
	**/
	public ISLPWMultiAff unionLexMax(ISLPWMultiAff pma2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_union_lexmax) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma2);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_union_lexmax(getNativePtr(this), getNativePtr(pma2)));
			} finally {
				taken(this);
				taken(pma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_range_product 
	 * 
	 * @take this pma2
	 * @generated
	**/
	public ISLPWMultiAff rangeProduct(ISLPWMultiAff pma2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_range_product) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma2);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_range_product(getNativePtr(this), getNativePtr(pma2)));
			} finally {
				taken(this);
				taken(pma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_flat_range_product 
	 * 
	 * @take this pma2
	 * @generated
	**/
	public ISLPWMultiAff flatRangeProduct(ISLPWMultiAff pma2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_flat_range_product) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma2);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_flat_range_product(getNativePtr(this), getNativePtr(pma2)));
			} finally {
				taken(this);
				taken(pma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_product 
	 * 
	 * @take this pma2
	 * @generated
	**/
	public ISLPWMultiAff product(ISLPWMultiAff pma2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_product) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma2);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_product(getNativePtr(this), getNativePtr(pma2)));
			} finally {
				taken(this);
				taken(pma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_intersect_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLPWMultiAff islPwMultiAffIntersectParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_intersect_params) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_intersect_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_intersect_domain 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLPWMultiAff intersectDomain(ISLSet set) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_intersect_domain) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_intersect_domain(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_project_domain_on_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff projectDomainOnParams() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_project_domain_on_params) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_project_domain_on_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLPWMultiAff alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_align_params) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff coalesce() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_coalesce) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_gist 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLPWMultiAff gist(ISLSet set) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_gist) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_gist(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_intersect_domain_wrapped_domain 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLPWMultiAff intersectDomainWrappedDomain(ISLSet set) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_intersect_domain_wrapped_domain) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_intersect_domain_wrapped_domain(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_intersect_domain_wrapped_range 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLPWMultiAff intersectDomainWrappedRange(ISLSet set) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_intersect_domain_wrapped_range) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_intersect_domain_wrapped_range(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_numberof_piece 
	 * 
	 * @generated
	**/
	public int getNbPieces() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_numberof_piece) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_multi_aff_numberof_piece(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_get_piece_at 
	 * 
	 * @generated
	**/
	public ISLPWMultiAffPiece getPiece(int pos) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_get_piece_at) DISABLED START ***/
		ISLPWMultiAffPiece res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWMultiAffPiece.build(ISLNative.isl_pw_multi_aff_get_piece_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLPWMultiAff_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
